'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _echarts = require('echarts');

var _echarts2 = _interopRequireDefault(_echarts);

var _elementResizeEvent = require('element-resize-event');

var _elementResizeEvent2 = _interopRequireDefault(_elementResizeEvent);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  /*eslint-disable */
  style: _propTypes2.default.object,
  theme: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
  group: _propTypes2.default.string,
  option: _propTypes2.default.object.isRequired,
  // 是否不跟之前设置的option进行合并，默认为true，不合并
  notMerge: _propTypes2.default.bool,
  // 在设置完option后是否不立即刷新画布，默认为false，即立即刷新
  notRefreshImmediately: _propTypes2.default.bool,
  /*eslint-disable */
  onEvents: _propTypes2.default.object
};

var defaultProps = {
  notMerge: true,
  notRefreshImmediately: false,
  onEvents: {},
  style: {},
  theme: {}
};

var ECharts = function (_Component) {
  _inherits(ECharts, _Component);

  function ECharts() {
    _classCallCheck(this, ECharts);

    return _possibleConstructorReturn(this, (ECharts.__proto__ || Object.getPrototypeOf(ECharts)).apply(this, arguments));
  }

  _createClass(ECharts, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.init();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderEcharts();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.dispose();
    }
  }, {
    key: 'init',
    value: function init() {
      this.chart = _echarts2.default.init(this.container, this.props.theme);
      this.renderEcharts();
      this.initEvents();
    }
  }, {
    key: 'initEvents',
    value: function initEvents() {
      var _this2 = this;

      var onEvents = this.props.onEvents;
      for (var eventName in onEvents) {
        this.chart.on(eventName, onEvents[eventName]);
      }

      (0, _elementResizeEvent2.default)(this.container, function () {
        _this2.chart.resize();
      });
    }
  }, {
    key: 'dispose',
    value: function dispose() {
      if (this.chart) {
        this.chart.dispose();
        this.chart = null;
      }
    }
  }, {
    key: 'renderEcharts',
    value: function renderEcharts() {
      var _props = this.props,
          option = _props.option,
          notMerge = _props.notMerge,
          notRefreshImmediately = _props.notRefreshImmediately;

      this.chart.showLoading();
      this.chart.setOption(option, notMerge, notRefreshImmediately);
      this.chart.hideLoading();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          id = _props2.id,
          option = _props2.option,
          style = _props2.style,
          props = _objectWithoutProperties(_props2, ['id', 'option', 'style']);

      var styles = Object.assign({
        width: '100%',
        height: '100%'
      }, style);

      var elementProps = (0, _omit2.default)(props, Object.keys(propTypes));

      return _react2.default.createElement('div', _extends({}, elementProps, {
        id: id,
        ref: function ref(_ref) {
          _this3.container = _ref;
        },
        style: styles
      }));
    }
  }]);

  return ECharts;
}(_react.Component);

ECharts.propTypes = propTypes;
ECharts.defaultProps = defaultProps;
ECharts.displayName = 'ECharts';

var APIS = ['getMap', 'connect', 'disConnect', 'getInstanceByDom', 'registerMap', 'registerTheme'];
APIS.forEach(function (api) {
  ECharts[api] = _echarts2.default[api];
});

ECharts.dispatchAction = function (instance, payload) {

  var container = (0, _get2.default)(instance, 'container') || document.getElementById(instance);
  var chartInstance = _echarts2.default.getInstanceByDom(container);
  return chartInstance.dispatchAction(payload);
};

exports.default = ECharts;